package com.sun.corba.se.impl.dynamicany;

import java.io.Serializable;
import org.omg.DynamicAny.DynAnyPackage.TypeMismatch;
import org.omg.DynamicAny.DynAnyPackage.InvalidValue;
import org.omg.CORBA.portable.OutputStream;
import org.omg.CORBA.portable.InputStream;
import org.omg.DynamicAny.DynAnyFactoryPackage.InconsistentTypeCode;
import org.omg.DynamicAny.DynAny;
import org.omg.CORBA.BAD_OPERATION;
import org.omg.CORBA.TypeCode;
import com.sun.corba.se.spi.orb.ORB;
import org.omg.CORBA.Any;
import org.omg.DynamicAny.DynSequence;

public class DynSequenceImpl extends DynAnyCollectionImpl implements DynSequence
{
    private DynSequenceImpl() {
        this(null, (Any)null, false);
    }
    
    protected DynSequenceImpl(ORB orb, Any any, boolean b) {
        super(orb, any, b);
    }
    
    protected DynSequenceImpl(ORB orb, TypeCode typeCode) {
        super(orb, typeCode);
    }
    
    protected boolean initializeComponentsFromAny() {
        this.any.type();
        TypeCode contentType = this.getContentType();
        InputStream create_input_stream;
        try {
            create_input_stream = this.any.create_input_stream();
        }
        catch (BAD_OPERATION bad_OPERATION) {
            return false;
        }
        int read_long = create_input_stream.read_long();
        this.components = new DynAny[read_long];
        this.anys = new Any[read_long];
        for (int i = 0; i < read_long; ++i) {
            this.anys[i] = DynAnyUtil.extractAnyFromStream(contentType, create_input_stream, this.orb);
            try {
                this.components[i] = DynAnyUtil.createMostDerivedDynAny(this.anys[i], this.orb, false);
            }
            catch (InconsistentTypeCode inconsistentTypeCode) {}
        }
        return true;
    }
    
    protected boolean initializeComponentsFromTypeCode() {
        this.components = new DynAny[0];
        this.anys = new Any[0];
        return true;
    }
    
    protected boolean initializeAnyFromComponents() {
        OutputStream create_output_stream = this.any.create_output_stream();
        create_output_stream.write_long(this.components.length);
        for (int i = 0; i < this.components.length; ++i) {
            if ((this.components[i] instanceof DynAnyImpl)) {
                ((DynAnyImpl)this.components[i]).writeAny(create_output_stream);
            }
            else {
                this.components[i].to_any().write_value(create_output_stream);
            }
        }
        this.any.read_value(create_output_stream.create_input_stream(), this.any.type());
        return true;
    }
    
    public int get_length() {
        if (this.status == 2) {
            throw this.wrapper.dynAnyDestroyed();
        }
        return this.checkInitComponents() ? this.components.length : 0;
    }
    
    public void set_length(int n) throws InvalidValue {
        if (this.status == 2) {
            throw this.wrapper.dynAnyDestroyed();
        }
        int bound = this.getBound();
        if (bound > 0 && n > bound) {
            throw new InvalidValue();
        }
        this.checkInitComponents();
        int i = this.components.length;
        if (n > i) {
            DynAny[] components2 = new DynAny[n];
            Any[] anys2 = new Any[n];
            System.arraycopy(this.components, 0, components2, 0, i);
            System.arraycopy(this.anys, 0, anys2, 0, i);
            this.components = components2;
            this.anys = anys2;
            TypeCode contentType = this.getContentType();
            for (; i < n; ++i) {
                this.createDefaultComponentAt(i, contentType);
            }
            if (this.index == -1) {
                this.index = i;
            }
        }
        else if (n < i) {
            DynAny[] components = new DynAny[n];
            Any[] anys = new Any[n];
            System.arraycopy(this.components, 0, components, 0, n);
            System.arraycopy(this.anys, 0, anys, 0, n);
            this.components = components;
            this.anys = anys;
            if (n == 0 || this.index >= n) {
                this.index = -1;
            }
        }
        else if (this.index == -1 && n > 0) {
            this.index = 0;
        }
        return;
    }
    
    @Override
    protected void checkValue(Object[] array) throws InvalidValue {
        if (array == null || array.length == 0) {
            this.clearData();
            this.index = -1;
            return;
        }
        this.index = 0;
        int bound = this.getBound();
        if (bound > 0 && array.length > bound) {
            throw new InvalidValue();
        }
        return;
    }
}
